###
# Modern Albufeira Prolog Interpreter
#
# Warranty & Liability
# To the extent permitted by applicable law and unless explicitly
# otherwise agreed upon, XLOG Technologies AG makes no warranties
# regarding the provided information. XLOG Technologies AG assumes
# no liability that any problems might be solved with the information
# provided by XLOG Technologies AG.
#
# Rights & License
# All industrial property rights regarding the information - copyright
# and patent rights in particular - are the sole property of XLOG
# Technologies AG. If the company was not the originator of some
# excerpts, XLOG Technologies AG has at least obtained the right to
# reproduce, change and translate the information.
#
# Reproduction is restricted to the whole unaltered document. Reproduction
# of the information is only allowed for non-commercial uses. Selling,
# giving away or letting of the execution of the library is prohibited.
# The library can be distributed as part of your applications and libraries
# for execution provided this comment remains unchanged.
#
# Restrictions
# Only to be distributed with programs that add significant and primary
# functionality to the library. Not to be distributed with additional
# software intended to replace any components of the library.
#
# Trademarks
# Jekejeke is a registered trademark of XLOG Technologies AG.
##

from nova.core import (make_check, exec_build, deref,
       is_structure, add,  assoc_set, assoc_get,
       VAR_MASK_SEEN, VAR_MASK_SERNO, Item,
       stack_pop, stack_peek, stack_push,
       exec_unify, Compound, Variable, is_compound,
       is_variable, bind, object_equals, walk_vars,
       union_find, union_add, union_undo)


################################################################
# subsumes/2                                                   #
################################################################

###
# subsumes(X, Y): [N208 8.2.4]
# The built-in succeeds if X subsumes Y.
##
def test_subsumes(args):
    alpha = exec_build(args[0])
    beta = exec_build(args[1])
    return subsumes(alpha, beta)


###
# Determine whether two terms single side unify.
# As a side effect the trail is extended, even if unification fails.
# Tail recursive solution.
#
# @param first The first term.
# @param second The second term.
# @return True if the two terms single side unify, otherwise false.
##
def subsumes(first, second):

    def subsumes2(first2, second2):
        nonlocal second
        while True:
            first2 = deref(first2)
            second2 = deref(second2)
            if is_variable(first2):
                if is_variable(second2) and first2 is second2:
                    return True
                if has_var(first2, second):
                    return False
                bind(second2, first2)
                return True
            if is_variable(second2):
                return False
            if not is_structure(first2):
                return object_equals(first2, second2)
            if not is_structure(second2):
                return False
            if len(first2.args) != len(second2.args):
                return False
            if first2.functor != second2.functor:
                return False
            first2 = first2.args
            second2 = second2.args
            i = 0
            while i < len(first2) - 1:
                if not subsumes2(first2[i], second2[i]):
                    return False
                i += 1
            first2 = first2[i]
            second2 = second2[i]

    return subsumes2(first, second)


################################################################
# unify_with_occurs_check/2                                    #
################################################################

###
# unify_with_occurs_check(S, T): [ISO 8.2.2]
# The built-in succeeds when the Prolog terms S and T unify
# with occurs check, otherwise the built-in fails.
##
def test_unify_checked(args):
    alpha = exec_build(args[0])
    beta = exec_build(args[1])
    return unify_checked(alpha, beta)


###
# Determine whether two terms unify with occurs check.
# As a side effect the trail is extended, even if unification fails.
# Can handle cyclic terms and deep recursion.
#
# @param first The first term.
# @param second The second term.
# @return True if the two terms unify, otherwise false.
##
def unify_checked(first, second):
    stack = None
    log = None
    try:
        while True:
            first = deref(first)
            second = deref(second)
            if is_variable(first):
                if not is_variable(second) or first is not second:
                    if has_var(first, second):
                        break
                    bind(second, first)
            elif is_variable(second):
                if has_var(second, first):
                    break
                bind(first, second)
            elif not is_structure(first):
                if not object_equals(first, second):
                    break
            elif not is_structure(second):
                break
            elif len(first.args) != len(second.args):
                break
            else:
                first = union_find(first)
                second = union_find(second)
                if first.functor != second.functor:
                    break
                elif first is not second:
                    log = union_add(log, first, second)
                    if 0 != len(first.args) - 1:
                        item = Item(first, second, 0)
                        stack = stack_push(stack, item)
                    first = first.args[0]
                    second = second.args[0]
                    continue
            item = stack_peek(stack)
            if item is None:
                return True
            else:
                item.idx += 1
                first = item.first.args[item.idx]
                second = item.second.args[item.idx]
                if item.idx == len(item.first.args) - 1:
                    stack_pop(stack)
        return False
    finally:
        union_undo(log)


################################################################
# occurs_check/2                                               #
################################################################

##
# occurs_check(S, T): [ISO 7.3.3]
# The built-in succeeds when the Prolog variable S occurs
# in the Prolog term T, otherwise the built-in fails.
##
def test_has_var(args):
    alpha = exec_build(args[0])
    beta = exec_build(args[1])
    return is_variable(alpha) and has_var(alpha, beta)


###
# Check whether a variable occurs in a term.
# Can handle cyclic terms and deep recursion.
#
# @param vterm The Prolog variable.
# @param first The Prolog term.
# @return True if vterm occurs in alpha, otherwise false.
##
def has_var(vterm, first):

    def has_var2(node):
        return node is vterm

    res = walk_vars(first, has_var2, VAR_MASK_SEEN)
    walk_vars(first, has_var2, 0)
    return res


################################################################
# acyclic_term/1                                               #
################################################################

###
# acyclic_term(T): [TC2 8.3.11]
# The predicate succeeds when the Prolog term T is an acyclic term,
# otherwise the predicate fails.
##
def test_acyclic_term(args):
    alpha = exec_build(args[0])
    res = walk_acyclic(alpha, VAR_MASK_SEEN)
    walk_acyclic(alpha, 0)
    return not res


###
# Walk a Prolog term completely or partially.
#
# @param first The Prolog term.
# @param state The desired state.
# @return True if the walk was complete, otherwise false.
##
def walk_acyclic(first, state):
    stack = None
    while True:
        first = deref(first)
        if is_compound(first):
            if (first.walk & VAR_MASK_SEEN) != state:
                first.walk = (first.walk & ~VAR_MASK_SEEN) | state
                first.walk &= ~VAR_MASK_SERNO
                stack = stack_push(stack, first)
                first = first.args[0]
                continue
            elif ((first.walk & VAR_MASK_SERNO)
                  != len(first.args)):
                return True
        item = stack_peek(stack)
        while (item is not None and
               (item.walk & VAR_MASK_SERNO) == len(item.args) - 1):
            item.walk += 1
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return False
        else:
            item.walk += 1
            first = item.args[item.walk & VAR_MASK_SERNO]


################################################################
# sys_acyclic_decompose/2                                      #
################################################################

###
# sys_acyclic_decompose(X, T, L):
# The built-in succeeds in R with skeleton and substitution
# list cells so that the substitions applied to the skeletons gives
# identical the elements of the Prolog list L.
##
def test_sys_acyclic_decompose(args):
    alpha = exec_build(args[0])
    vmap = {}
    back = None
    res = None
    while (is_structure(alpha) and
           alpha.functor == "." and
           len(alpha.args) == 2):
        temp = deref(alpha.args[0])
        temp = walk_decom(vmap, temp)
        temp = Compound(".", [temp, NotImplemented])
        if back is None:
            res = temp
        else:
            back.args[1] = temp
        back = temp
        alpha = deref(alpha.args[1])
    if back is None:
        res = "[]"
    else:
        back.args[1] = "[]"
    return exec_unify(args[1], res)


###
# Walk a Prolog term completely.
#
# @param vmap The compound map.
# @param first The Prolog term.
# @return The decomp.
##
def walk_decom(vmap, first):
    stack = None
    subst = "[]"
    while True:
        first = deref(first)
        if is_compound(first):
            peek = assoc_get(vmap, first)
            if peek is NotImplemented:
                vmap = assoc_set(vmap, first, None)
                peek = Compound(first.functor,
                           [NotImplemented] * len(first.args))
                item = Item(first, peek, 0)
                stack = stack_push(stack, item)
                first = first.args[0]
                continue
            else:
                if peek is None:
                    peek = Variable()
                    vmap = assoc_set(vmap, first, peek)
                first = peek
        item = stack_peek(stack)
        while (item is not None and
               item.idx == len(item.first.args) - 1):
            item.second.args[item.idx] = first
            first = item.second
            peek = assoc_get(vmap, item.first)
            if peek is None:
                vmap = assoc_set(vmap, item.first, first)
            else:
                first = Compound("=", [peek, first])
                subst = Compound(".", [first, subst])
                first = peek
            stack_pop(stack)
            item = stack_peek(stack)
        if item is None:
            return Compound(".", [first,subst])
        else:
            item.second.args[item.idx] = first
            item.idx += 1
            first = item.first.args[item.idx]


#######################################################################
# Cyc Lib Init                                                        #
#######################################################################

def main():
    add("subsumes", 2, make_check(test_subsumes))
    add("unify_with_occurs_check", 2, make_check(test_unify_checked))
    add("occurs_check", 2, make_check(test_has_var))
    add("acyclic_term", 1, make_check(test_acyclic_term))
    add("sys_acyclic_decompose", 2, make_check(test_sys_acyclic_decompose))
